# anjunbang-backend
Blockchain-based Real Estate Auction Platform (Blockchain and Practical Applications, 2022 Spring)

## Subject
Blockchain-based Real Estate Auction Application

## Function
- User management
- Product management
- Auction management
- Bid management

## Architecture

![archtecture](images/architecture.png)

## API Spec
- Issue 참조

## Deployment

### Application build (on Local)
```
// Requires java version 8 or higher
./gradlew bootJar
```

---

### Docker image build and push (on Local)
```
// Requires aws cli and docker
aws ecr get-login-password --region ap-northeast-2 | docker login --username AWS --password-stdin {AWS ECR Endpoint}
docker buildx build -t anjunbang-backend . --platform linux/amd64
docker tag anjunbang-backend:latest {AWS ECR Endpoint}/anjunbang-backend:latest
docker push {AWS ECR Endpoint}/anjunbang-backend:{tag}
```

---

### Docker image pull (on EC2)
```
// Requires java version 8 or higher
// Requires aws cli and docker
aws ecr get-login-password --region ap-northeast-2 | docker login --username AWS --password-stdin {AWS ECR Endpoint}
docker pull {AWS ECR Endpoint}/anjunbang-backend:{tag}
```

---

### Docker container run (on EC2)
```
// Requires that port of inbound, outbound of EC2 security group must be open.
docker images
docker run -d -p 80:8080 {docker image id}
// If you want to check the log
docker ps
docker log -t -f {docker container id}
```

---

