package com.snucse.anjunbang.controller

import com.snucse.anjunbang.dto.BidDto
import com.snucse.anjunbang.service.bid.BidService
import org.springframework.beans.factory.annotation.Autowired
import org.springframework.http.HttpHeaders
import org.springframework.http.ResponseEntity
import org.springframework.web.bind.annotation.*

@RestController
@RequestMapping("/api/v1/bids")
class BidController(
        @Autowired private val bidService: BidService
) {
    @PostMapping("/create")
    fun createBid(@RequestBody createBidReq: BidDto.CreateBidReq): ResponseEntity<BidDto.BidRes>{
        return ResponseEntity
                .ok()
                .header(HttpHeaders.CONTENT_TYPE, "application/json")
                .body(bidService.createBid(createBidReq))
    }

    @GetMapping
    fun getBids(@RequestParam userId: Long?, @RequestParam auctionId: Long?): ResponseEntity<List<BidDto.BidRes>>{
        var bids: List<BidDto.BidRes> = listOf()

        if(userId != null && auctionId != null){
            bids = bidService.getBidsByUserAndAuction(userId, auctionId)
        }
        else if(userId != null && auctionId == null){
            bids = bidService.getBidsByUser(userId)
        }
        else if(userId == null && auctionId != null){
            bids = bidService.getBidsByAuction(auctionId)
        }
        else{
            bids = bidService.getBids()
        }

        return ResponseEntity
                .ok()
                .header(HttpHeaders.CONTENT_TYPE, "application/json")
                .body(bids)
    }

    @GetMapping("/{id}")
    fun getBid(@PathVariable id: Long): ResponseEntity<BidDto.BidRes>{
        return ResponseEntity
                .ok()
                .header(HttpHeaders.CONTENT_TYPE, "application/json")
                .body(bidService.getBid(id))
    }
}