package com.snucse.anjunbang.controller

import com.snucse.anjunbang.dto.UserDto
import com.snucse.anjunbang.service.user.UserService
import org.springframework.beans.factory.annotation.Autowired
import org.springframework.http.HttpHeaders
import org.springframework.http.ResponseEntity
import org.springframework.web.bind.annotation.*

@RestController
@RequestMapping("/api/v1/users")
class UsersController(
        @Autowired private val userService: UserService
) {
    @PostMapping("/signup")
    fun signUp(@RequestBody signUpReq: UserDto.SignUpReq): ResponseEntity<UserDto.UserRes>{
        return ResponseEntity
                .ok()
                .header(HttpHeaders.CONTENT_TYPE, "application/json")
                .body(userService.signUp(signUpReq))
    }

    @PostMapping("/signin")
    fun signIn(@RequestBody signInReq: UserDto.SignInReq): ResponseEntity<UserDto.UserRes>{
        return ResponseEntity
                .ok()
                .header(HttpHeaders.CONTENT_TYPE, "application/json")
                .body(userService.signIn(signInReq))
    }
}