package com.snucse.anjunbang.domain

import com.fasterxml.jackson.annotation.JsonIgnore
import com.snucse.anjunbang.dto.BidDto
import java.time.LocalDateTime
import javax.persistence.*

@Entity
@Table(name = "bid")
data class Bid(
        @Id @GeneratedValue(strategy =  GenerationType.IDENTITY)
        var id: Long? = null,
        var createdAt: LocalDateTime? = null,
        var price : Long,

        @ManyToOne(fetch = FetchType.LAZY)
        @JoinColumn(name = "user_id")
        var user: User,

        @JsonIgnore
        @ManyToOne(fetch = FetchType.LAZY)
        @JoinColumn(name = "auction_id")
        var auction: Auction
) {
        companion object{
                fun createBid(createBidReq: BidDto.CreateBidReq, user: User, auction: Auction) = Bid(
                        createdAt = LocalDateTime.now(),
                        price = createBidReq.price,
                        user = user,
                        auction =  auction
                )
        }

        fun toBidRes() = BidDto.BidRes(
                bidId = id!!,
                createdAt = createdAt,
                price = price,
                user = user.toUserRes()
        )
}