package com.snucse.anjunbang.domain

import com.snucse.anjunbang.dto.UserDto
import org.springframework.security.crypto.bcrypt.BCryptPasswordEncoder
import javax.persistence.*

@Entity
@Table(name = "users")
data class User (
        @Id @GeneratedValue(strategy =  GenerationType.IDENTITY)
        var id: Long? = null,

        @Column(name = "email", unique = true, length = 200)
        var email: String,
        var password: String,

        @Column(name = "nickname", unique = true, length = 20)
        var nickname: String
) {

        fun toSignUpRes() = UserDto.UserRes(
                userId = id!!,
                email = email,
                nickname = nickname
        )

        fun toSignInRes() = UserDto.UserRes(
                userId = id!!,
                email = email,
                nickname = nickname
        )

        fun toUserRes() = UserDto.UserRes(
                userId = id!!,
                email = email,
                nickname = nickname
        )

        fun isRightPassword(bCryptPasswordEncoder: BCryptPasswordEncoder, rawPassword: String): Boolean{
                return bCryptPasswordEncoder.matches(rawPassword, password)
        }
}