package com.snucse.anjunbang.dto

import com.snucse.anjunbang.domain.AuctionState
import com.snucse.anjunbang.domain.Bid
import java.time.LocalDateTime

class AuctionDto {
    data class CreateAuctionReq(
            var userId: Long,
            var productId: Long,

            var title: String,
            var description: String,

            var startAt: LocalDateTime,
            var endAt: LocalDateTime
    )

    data class AuctionRes(
            var auctionId: Long,
            var title: String,
            var description: String,
            var startAt: String,
            var endAt: String,
            var product: ProductDto.ProductRes,
            var bids: List<BidDto.BidRes>,
            var auctionState: AuctionState? = AuctionState.PROCESSING
    )
}