package com.snucse.anjunbang.dto

import com.snucse.anjunbang.domain.User
import org.springframework.security.crypto.bcrypt.BCryptPasswordEncoder

class UserDto {
    data class SignUpReq(
            var email: String,
            var password: String,
            var nickname: String
    ){
        fun toEntity(bCryptPasswordEncoder: BCryptPasswordEncoder) = User(
                email = email,
                password = bCryptPasswordEncoder.encode(password),
                nickname = nickname
        )
    }

    data class SignInReq(
            var email: String,
            var password: String
    )

    data class UserRes(
            var userId: Long,
            var email: String,
            var nickname: String
    )
}