package com.snucse.anjunbang.service.product.image

import com.snucse.anjunbang.domain.ProductImage
import com.snucse.anjunbang.repository.ProductImageRepository
import org.springframework.beans.factory.annotation.Autowired
import org.springframework.stereotype.Service
import javax.transaction.Transactional

@Service
@Transactional
class ProductImageServiceImpl(
        @Autowired private val productImageRepository: ProductImageRepository
): ProductImageService {

    override fun createProductImages(imageUrls: List<String>): MutableList<ProductImage>{
        return imageUrls.map { imageUrl ->  createProductImage(imageUrl)}.toMutableList()
    }

    fun createProductImage(imageUrl: String): ProductImage{
        return productImageRepository.save(ProductImage.createImageUrl(imageUrl))
    }
}